#version 330 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoords;

out VS_OUT {
    vec3 Normal;
    vec2 TexCoords;
} vsOut;

uniform mat4 projection;
uniform mat4 view;
uniform mat4 model;

void main()
{
	mat4 modelView = view * model;

    gl_Position = projection * modelView * vec4(position, 1.0f);
    vsOut.Normal = (mat3(view * model)) * normal;
    vsOut.TexCoords = texCoords;
}